﻿#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;
int main() {
    const size_t SCREEN_WIDTH = 80;
    const size_t MAX_ASTERISK = SCREEN_WIDTH - 3 - 1;
    size_t number_count;
    cerr << "Enter number count:";
    cin >> number_count;
    vector<double> numbers(number_count);
    cerr << "Enter numbers:";
    for (int i = 0; i < number_count; i++) {
        cin >> numbers[i];
    }
    sort(begin(numbers), end(numbers));
    numbers.erase(unique(begin(numbers), end(numbers)), end(numbers));
    number_count = numbers.size();
  
    size_t bin_count;
    cerr << "Enter bin count:";
    cin >> bin_count;
    vector<size_t> bins(bin_count);
    double min = numbers[0];
    double max = numbers[0];
    for (double x : numbers) {
        if (x < min) {
            min = x;
        }
        else if (x > max) {
            max = x;
        }
    }
    size_t max_count = 0;
    double bin_size = (max - min) / bin_count;
    for (size_t i = 0; i < number_count; i++) {
        bool found = false;
        for (size_t j = 0; (j < bin_count - 1) && !found; j++) {
            auto lo = min + j * bin_size;
            auto hi = min + (j + 1) * bin_size;
            if ((lo <= numbers[i]) && (numbers[i] < hi)) {
                bins[j]++;
                found = true;
            }
        }
        if (!found) {
            bins[bin_count - 1]++;
        }
        for (size_t i = 0; i < bin_count; i++) {
            if (bins[i] > max_count) {
                max_count = bins[i];
            }
        }
    }
    double kof = double(MAX_ASTERISK) / max_count;
    if (kof > 1) {
        kof = 1;
    }
    for (size_t bin : bins) {
        if (bin < 100) {
            cout << " ";
        }
        if (bin < 10) {
            cout << " ";
        }
        cout << bin << "|";
        for (size_t i = 0; i < size_t(bin * kof); i++) {
            cout << "*";
        }

        cout << endl;
    }
    return 0;
}